        subroutine cte_model_noprec(elec_un,p,npar,el_l)
        
        implicit none
        integer npar, jj,j, nhot,nhot_disc, mode, nnp
        real    sigma, rnt0,rn00,rnel,rne_old
        real    temp,pi,rkb,sigmax,vth,rnc,et,en, ap,bp,cp,tzyk,
     &          tphi1,tsonst,t,phi_factor,t_frame
        real    fact1, fact2, fact3, fact4, fact5, scale
        real    elec_un, sumt, rm0, sum, s, high, rlow, el_l
        real    rnec_noprec
        real p(npar)
        external rnec_noprec

        common /model_par/ temp,pi,rkb,sigmax,vth,rnc,et,en,
     &                     ap,bp,cp,tzyk,tphi1,tsonst,
     &                     t,phi_factor,t_frame,nhot,nhot_disc,mode,nnp
        common /timing_fac/ scale

        common /data/ sigma,rnt0,rn00,rnel,rne_old
        common /factors/ fact1,fact2,fact3,fact4,fact5
        common /index1/ jj,j

        sigma=p(1)*vth
        rnt0=p(2)
        high=fact5
        rlow=high*p(3)

        rnel=elec_un*sigma

        sumt=0.
        do jj=1,2
          if(jj.eq.1) then
            t=tphi1
            rm0=(high-rlow)/5.
          else
            t=tsonst
            rm0=fact4
          endif
          sum=0.
          do j=1,5
            call qsfmy(rnec_noprec,j,s)
            if(s.eq.0.) go to 2
            if(j.eq.1.or.sum.eq.0.) go to 1
            if(abs(s/sum).le.1e-2) go to 2        
1           sum=sum+s        
          enddo
2         sum=sum*rm0/12.        
          if(jj.eq.1) then 
            sumt=sum
          else
            sumt=sumt*scale+phi_factor*sum
          endif
        enddo
        el_l=sumt*fact3

        end
c
c------------------------------------------------------------------------
c
        real function rnec_noprec(k)

        implicit none
        integer k
        integer jj
        integer nhot,nhot_disc, mode, nnp
        real    sigma, rnt0,rn00,rnel,rne_old
        real    temp,pi,rkb,sigmax,vth,rnc,et,en, ap,bp,cp,tzyk,
     &          tphi1,tsonst,t,phi_factor,t_frame
        real    fact1, fact2, fact3, fact4, fact5
        real    a2,a3
        integer ii, j, icol
        real rad(768,2,25),gau(768,2,25)
        common /two_arrays/ rad,gau
        common /index1/ ii,j
        common /index2/ icol


        common /model_par/ temp,pi,rkb,sigmax,vth,rnc,et,en,
     &                     ap,bp,cp,tzyk,tphi1,tsonst,
     &                     t,phi_factor,t_frame,nhot,nhot_disc,mode,nnp

        common /data/ sigma,rnt0,rn00,rnel,rne_old
        common /factors/ fact1,fact2,fact3,fact4,fact5


        jj=(j-1)*5+k

        a3=rnel*gau(icol,ii,jj)
        a2=en+a3

        rnec_noprec=rad(icol,ii,jj)*a3*rnt0/a2*(1.-exp(-t*a2))

        end
C
C---------------------------------------------------------------------
C
        subroutine qsfmy(f,j,s)

        implicit none
        integer i,j
        real fr(5), frr, s, f
        logical jeq1
        external f
        save frr

        jeq1 = (j.eq.1)
        do i=1,5
          if(jeq1.or.i.gt.1) then
            fr(i)=f(i)
          else
            fr(1)=frr
          endif
        enddo
        frr=fr(5)

C       s=fr(1)+4.*fr(2)+2.*fr(3)+4.*fr(4)+fr(5)
        s=fr(1)+4.*(fr(2)+fr(4))+2.*fr(3)+fr(5)

        end
C
