        subroutine cte_model_prec(elec_un,elec_old,p,npar,el_l)
        implicit none
        integer npar, jj,j, nhot,nhot_disc, mode, nnp
        real    sigma, rnt0,rn00,rnel,rne_old
        real    temp,pi,rkb,sigmax,vth,rnc,et,en, ap,bp,cp,tzyk,
     &          tphi1,tsonst,t,phi_factor,t_frame
        real    fact1, fact2, fact3, fact4, fact5, scale
        real    elec_un, elec_old, sumt, rm0, sum, s, high, rlow, el_l
        real    rnec_prec
        real p(npar)
        logical jjeq1

        external rnec_prec

        common /model_par/ temp,pi,rkb,sigmax,vth,rnc,et,en,
     &                     ap,bp,cp,tzyk,tphi1,tsonst,
     &                     t,phi_factor,t_frame,nhot,nhot_disc,mode,nnp
        common /timing_fac/ scale

        common /data/ sigma,rnt0,rn00,rnel,rne_old
        common /factors/ fact1,fact2,fact3,fact4,fact5
        common /index1/ jj,j

        sigma=p(1)*vth
        rnt0=p(2)
        high=fact5
        rlow=high*p(3)

        rnel=elec_un
        rne_old=elec_old

        sumt=0.
        do jj=1,2
          jjeq1 = (jj.eq.1)
          if (jjeq1) then
            t=tphi1
            rm0=(high-rlow)/5.
          else
            t=tsonst
            rm0=fact4
          endif
          sum=0.
          do j=1,5
            call qsfmy(rnec_prec,j,s)
            if(s.eq.0.) go to 2
            if(j.eq.1.or.sum.eq.0.) go to 1
            if(abs(s/sum).le.1e-2) go to 2        
1           sum=sum+s        
          enddo
2         sum=sum*rm0/12.
          if (jjeq1) then 
            sumt=sum
          else
            sumt=sumt*scale+phi_factor*sum
          endif
        enddo
        el_l=sumt*fact3

        end
c
c------------------------------------------------------------------------
c
        real function rnec_prec(k)
        implicit none
        integer k
        integer jj
        integer nhot,nhot_disc, mode, nnp
        real    sigma, rnt0,rn00,rnel,rne_old
        real    temp,pi,rkb,sigmax,vth,rnc,et,en, ap,bp,cp,tzyk,
     &          tphi1,tsonst,t,phi_factor,t_frame
        real    fact1, fact2, fact3, fact4, fact5
        real    a2,a3, gauss, rnec0, rnt, rne0
        integer ii, j, icol
        real rad(768,2,25),gau(768,2,25)

        common /two_arrays/ rad,gau
        common /index1/ ii,j
        common /index2/ icol
        common /model_par/ temp,pi,rkb,sigmax,vth,rnc,et,en,
     &                     ap,bp,cp,tzyk,tphi1,tsonst,
     &                     t,phi_factor,t_frame,nhot,nhot_disc,mode,nnp
        common /data/ sigma,rnt0,rn00,rnel,rne_old
        common /factors/ fact1,fact2,fact3,fact4,fact5

        jj=(j-1)*5+k

        gauss=gau(icol,ii,jj)

        rnec0=rnt0        
        rnt=rne_old*gauss
        if(rnt0.gt.rnt) rnec0=rnt

        rne0=gauss*rnel+rnec0
        a3=sigma*rne0
        a2=en+a3

        rnec_prec=rad(icol,ii,jj)*(a3*rnt0/a2-rnec0)*(1.-exp(-t*a2))

        end
c
c---------------------------------------------------------------------
c
