#include <iostream>
#include "CalPnAlgo.h"


int main()
{
  float energy_lo = 1000.;
  float energy_hi = 1000.;
  int nchannel = 10;
  int line = 1;

  int nsiabs = 2;
  float sienergy[2];
  float siabs[2];
//    sienergy[0] = 5.904000E+01;
//    siabs   [0] = 2.650490E-03; // From sioabs.new *1e-7
//    sienergy[1] = 6.199000E+01;
//    siabs   [1] = 2.468820E-03; // From sioabs.new *1e-7
  sienergy[0] = 9.297000E+02;
  siabs   [0] = 4.547200E-04; // From sioabs.new *1e-7
  sienergy[1] = 1.011700E+03;
  siabs   [1] = 3.619200E-04; // From sioabs.new *1e-7


  int nsio2abs = 2;
  float sio2energy[2];
  float sio2abs[2];
//    sio2energy[0] = 5.904000E+01;
//    sio2abs   [0] = 2.614590E-02; // From sio2abs.new * 1e-7
//    sio2energy[1] = 6.199000E+01;
//    sio2abs   [1] = 2.349460E-02; // From sio2abs.new * 1e-7
  sio2energy[0] = 9.920000E+02;
  sio2abs   [0] = 5.946230E-04; // From sio2abs.new * 1e-7
  sio2energy[1] = 1.016000E+03 ;
  sio2abs   [1] = 5.583530E-04; // From sio2abs.new * 1e-7

  float echanmin[nchannel], echanmax[nchannel];
  
  for (int i = 0; i < nchannel; ++i)
    {
      echanmin[i] = i*1000;
      echanmax[i] = (i+1)*1000;
    }
  
  float response[nchannel];
  
  int pattern, pattfracchan;
  float pattfraction[nchannel];

  pattern=0;
  pattfracchan=nchannel;

  for (int i = 0; i < nchannel; ++i)
    {
     pattfraction[i]=1.0;
    }


  cout << " Calling CALPNALGO_resp ..." << endl;

  char *cmode = "ff";

  CALPNALGO_resp( energy_lo, 
		  energy_hi, 
		  nchannel,  
		  echanmin,
		  echanmax,
		  line,
	          cmode,
                  pattern,
                  pattfracchan,
                  pattfraction,
		  nsiabs,    
		  sienergy,  
		  siabs,     
		  nsio2abs,  
		  sio2energy, 
		  sio2abs,   
		  response);

  cout << " CALPNALGO_resp cal complete." << endl;

  for (int i = 0; i < nchannel; ++i)
    {
      cout << "response [" << i 
	   << "] = " << response[i]
	   << endl;
    }

  return 0;
}
